/*eslint max-depth: ["error", 10] max-statements: ["error", 30]*/
"use strict";
import { resolve, join } from "path";

class AppUtil {
    static getAppStructure() {
        const srcPath = resolve(join("src"));
        return {
            componentPath: resolve(join(srcPath, "Component")),
            configPath: resolve(join(srcPath, "Config")),
            controllersPath: resolve(join(srcPath, "Controller")),
            modelPath: resolve(join(srcPath, "Model")),
        }
    }

    static async importStaticFile(filePath, type = "json") {
        try {
            const file = await import(filePath, { assert: { type } });
            return file.default;
        } catch (error) {
            console.error(`Error importing file: ${filePath}`, error);
            throw error; // Re-throw the error after logging
        }
    }
}

export default AppUtil;
